{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
//{$WARNINGS OFF}
//=============================================================================
//  ϓtOf[V{^
//  Ver. 9.02
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  dlCCmFɂĂ͓YtReadme.txtQ
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plButton;

interface

uses
  Windows, Messages, Classes, Graphics, Controls,
  Forms, ExtCtrls, SysUtils,Dialogs;

type
  TplBtnAlignment   = ( taCenter, taLeft, taRight, taEven );
  TplButtonStyle    = ( bsNormal, bsFlat, bsFlatNoFrame, bsRoundRect, bsRoundRectNoFrame );
  //tbgȃ^Cv̎̃GbW̃^Cv
  TplBtnFrameType= ( bffFlat,   //
                     bffEtched, //񂾊
                     bffBump ); //オ

  TplButton = class;

  TplBtnCaption =class(TPersistent)
  private
    FplBtn          : TplButton;
    FCaption        : String;
    FAlignment      : TplBtnAlignment;
    FLeft           : Integer;
    FRight          : Integer;
    procedure SetOffset(const Index: Integer; const Value: Integer);
    procedure SetAlignment(const Value: TplBtnAlignment);
    procedure SetCaption(const Value: String);
  protected
  public
    constructor Create(plBtn: TplButton);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
  published
    property Caption   : String                  read FCaption   write SetCaption;
    property Alignment : TplBtnAlignment         read FAlignment write SetAlignment default taCenter;
    property Left      : Integer         index 1 read FLeft      write SetOffset    default 0;
    property Right     : Integer         index 2 read FRight     write SetOffset    default 0;
  end;

  TplBtnImage = class(TPersistent)
  private
    FplBtn       : TplButton;
    FPicture     : TPicture;
    FLeft        : Integer;
    FTop         : Integer;
    FTransParent : Boolean;
    FVisible     : Boolean;
    FVertCenter  : Boolean;
    FHorzCenter  : Boolean;
    procedure SetPicture(const Value: TPicture);
    procedure SetImageBool(const Index: Integer; const Value: Boolean);
    procedure SetImagePosition(const Index, Value: Integer);
 public
    constructor Create(plBtn: TplButton);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
  published
    property Picture     : TPicture         read FPicture     write SetPicture;
    property Left        : Integer  index 1 read FLeft        write SetImagePosition  default 10;
    property Top         : Integer  index 2 read FTop         write SetImagePosition;
    property Visible     : Boolean  index 1 read FVisible     write SetImageBool      default True;
    property TransParent : Boolean  index 2 read FTransParent write SetImageBool      default False;
    property VertCenter  : Boolean  index 3 read FVertCenter  write SetImageBool      default True;
    property HorzCenter  : Boolean  index 4 read FHorzCenter  write SetImageBool      default False;
  end;

  TplButton = class(TCustomPanel)
  private
    FButtonStyle       : TplButtonStyle;
    FCancel            : Boolean;
    FCaptionA          : TplBtnCaption;
    FCaptionB          : TplBtnCaption;
    FCaptionLineSpace  : Integer;
    FCaptionTop        : Integer;
    FCaptionVertCenter : Boolean;
    FFlatFrameType     : TplBtnFrameType;
    FGradation         : Boolean;
    FGradBeginColor    : TColor;
    FGradEndColor      : TColor;
    FHasFocus          : Boolean;
    FModalResult       : TModalResult;
    FImage             : TplBtnImage;
    FRoundDiameter     : Integer;
    BtnRect            : TRect;
    BtnRgn             : HRgn;
    FOnMouseEnter      : TMouseMoveEvent;
    FOnMouseExit       : TMouseMoveEvent;
    fgMouseDown        : Boolean;
    fgParent           : Boolean;

    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMEnabledChanged(var Message: TWMNoParams); message CM_ENABLEDCHANGED ;
    procedure CMParentColorChanged(var Message: TMessage); message CM_PARENTCOLORCHANGED;
    procedure CMDialogKey(var Message: TCMDialogKey); message CM_DIALOGKEY;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure SetGradation(const Value: Boolean);
    procedure SetGradColor(const Index: Integer; const Value: TColor);
    procedure SetButtonStyle(const Value: TplButtonStyle);
    procedure SetRoundDiameter(const Value: Integer);
    procedure SetCaptionVertCenter(const Value: Boolean);
    procedure SetCaptionLineSpace(const Value: Integer);
    procedure SetCaptionTop(const Value: Integer);
    procedure SetFlatFrameType(const Value: TplBtnFrameType);
    procedure SetHasFocus(const Value: Boolean);
    procedure SetCaptionAorB(const Index: Integer;
      const Value: TplBtnCaption);
    procedure SetImage(const Value: TplBtnImage);
  protected
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;
    procedure Loaded; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
    procedure MouseEnter(Shift: TShiftState; X, Y: Integer); dynamic;
    procedure MouseLeave(Shift: TShiftState; X, Y: Integer); dynamic;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
    procedure BtnDrawOnBitmapCanvas(ACanvas: TCanvas);
    procedure Paint; override;
    procedure DoEnter; override;
    procedure DoExit; override;
    procedure Click; override;
    procedure GradPaint(ACanvas: TCanvas);
    procedure BtnDrawFrame(ACanvas: TCanvas);
    procedure PutImagePicture(ACanvas: TCanvas);
    procedure BtnDrawInnerFrame(ACanvas: TCanvas);
    procedure BtnDrawCaption(ACanvas: TCanvas; ACap: TplBtnCaption; Y: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property RoundDiameter : Integer read FRoundDiameter write SetRoundDiameter;
  published
    property Action;
    property Anchors;
    property Align;
    property Color;
    property Enabled;
    property Font;
    property Hint;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop         default True;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnEnter;
    property OnExit;
    property OnKeyPress;
    property OnKeyDown;
    property OnMouseDown;
    property OnMouseEnter: TMouseMoveEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TMouseMoveEvent read FonMouseExit  write FOnMouseExit;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property ButtonStyle       : TplButtonStyle          read FButtonStyle       write SetButtonStyle default bsNormal;
    property Cancel            : Boolean                 read FCancel            write FCancel        default False;
    property Gradation         : Boolean                 read FGradation         write SetGradation   default True;
    property GradBeginColor    : TColor          index 1 read FGradBeginColor    write SetGradColor   default clWhite;
    property GradEndColor      : TColor          index 2 read FGradEndColor      write SetGradColor   default clSilver;
    property HasFocus          : Boolean                 read FHasFocus          write SetHasFocus    default True;
    property ModalResult       : TModalResult            read FModalResult       write FModalResult   default mrNone;
    property Image             : TplBtnImage             read FImage             write SetImage;
    property CaptionA          : TplBtnCaption   index 1 read FCaptionA          write SetCaptionAorB;
    property CaptionB          : TplBtnCaption   index 2 read FCaptionB          write SetCaptionAorB;
    property CaptionLineSpace  : Integer                 read FCaptionLineSpace  write SetCaptionLineSpace  default 4;
    property CaptionTop        : Integer                 read FCaptionTop        write SetCaptionTop;
    property CaptionVertCenter : Boolean                 read FCaptionVertCenter write SetCaptionVertCenter default True;
    property FlatFrameType     : TplBtnFrameType         read FFlatFrameType     write SetFlatFrameType     default bffFlat;

  end;

procedure Register;

implementation

const
  //ACg̑IɑΉl
  BtnAlign : array [TplBtnAlignment] of Integer=(TA_CENTER,TA_LEFT,TA_RIGHT,0);

{ TplBtnCaption }

//=============================================================================
//  LvV֌W̐ݒNX
//  Create
//=============================================================================
constructor TplBtnCaption.Create(plBtn: TplButton);
begin
  inherited Create;

  FplBtn     := plBtn;
  FAlignment := taCenter;
  FLeft      := 0;
  FRight     := 0;
end;

//=============================================================================
//  LvV֌W̐ݒNX
//  Create
//=============================================================================
destructor TplBtnCaption.Destroy;
begin
  inherited Destroy;
end;

//=============================================================================
//  LvV֌W̐ݒNX
//  TplBtnCaptioñRs[
//=============================================================================
procedure TplBtnCaption.Assign(Source: TPersistent);
begin
  if Source is TplBtnCaption then begin
    FAlignment := (Source as TplBtnCaption).FAlignment;
    FCaption   := (Source as TplBtnCaption).FCaption;
    FLeft      := (Source as TplBtnCaption).FLeft;
    FRight     := (Source as TplBtnCaption).FRight;
    FplBtn.Refresh;
  end else begin
    inherited;
  end;
end;

//=============================================================================
//  LvV֌W̐ݒNX
//  Alignment̐ݒ
//=============================================================================
procedure TplBtnCaption.SetAlignment(const Value: TplBtnAlignment);
begin
  if FAlignment <> Value then begin
    FAlignment := Value;
    FplBtn.Refresh;
  end;
end;

//=============================================================================
//  LvV֌W̐ݒNX
//  `ʒu̐ݒ
//=============================================================================
procedure TplBtnCaption.SetOffset(const Index, Value: Integer);
begin
  case Index of
  1:
  begin
    if FLeft <> Value then begin
      FLeft := Value;
      FplBtn.Refresh;
    end;
  end;
  2:
  begin
    if FRight <> Value then begin
      FRight := Value;
      FplBtn.Refresh;
    end;
  end;
  end;
end;

//=============================================================================
//  LvV֌W̐ݒNX
//  LvV̕`揈
//=============================================================================
procedure TplBtnCaption.SetCaption(const Value: String);
begin
  if FCaption <> Value then begin
    FCaption := Value;
    FplBtn.Refresh;
  end;
end;

{ TplBtnImage }

//=============================================================================
//  C[W֌W̐ݒNX
//  Create
//=============================================================================
constructor TplBtnImage.Create(plBtn: TplButton);
begin
  inherited Create;

  FplBtn       := plBtn;
  FPicture     := TPicture.Create;
  FTransParent := False;
  FVertCenter  := True;
  FHorzCenter  := False;
  FLeft        := 10;
  FVisible     := True;
end;

//=============================================================================
//  C[W֌W̐ݒNX
//  Destroy
//=============================================================================
destructor TplBtnImage.Destroy;
begin
  if FPicture<>nil then FPicture.Free;
  inherited Destroy;
end;

//=============================================================================
//  C[W֌W̐ݒNX
//  TplBtnImagẽRs[̑
//=============================================================================
procedure TplBtnImage.Assign(Source: TPersistent);
begin
  if Source is TplBtnImage then begin
    FPicture    := (Source as TplBtnImage).FPicture;
    FTransParent:= (Source as TplBtnImage).FTransParent;
    FVertCenter := (Source as TplBtnImage).FVertCenter;
    FHorzCenter := (Source as TplBtnImage).FHorzCenter;
    FTop        := (Source as TplBtnImage).FTop;
    FLeft       := (Source as TplBtnImage).FLeft;
    FVisible    := (Source as TplBtnImage).FVisible;
  end else begin
    inherited;
  end;
end;

//=============================================================================
//  C[W֌W̐ݒNX
//  C[WǍ񂾂炻̃C[W̃TCYŕ\
//  ̂BitmapIcon݂̂Ƃ
//=============================================================================
procedure TplBtnImage.SetPicture(const Value: TPicture);
begin
  if (FPicture <> Value) then begin
    FPicture.Assign(Value);
    if (FPicture.Graphic is TBitmap) or (FPicture.Graphic is TIcon) then begin
      FplBtn.Refresh;
    end else begin
      FPicture.Graphic := nil;
    end;
  end;
end;

//=============================================================================
//  C[W֌W̐ݒNX
//  _֌W̐ݒ
//  TransParent Trueœߕ`
//  Visible     Trueŕ\
//  HorzCenter  IɃ{^̍Eɕ\
//  VertCenter  IɃ{^̏㉺ɕ\
//=============================================================================
procedure TplBtnImage.SetImageBool(const Index: Integer;
  const Value: Boolean);
begin
  case Index of
  1:
  begin
    if FVisible <> Value then begin
      FVisible := Value;
      FplBtn.Refresh;
    end;
  end;
  2:
  begin
    if FTransParent <> Value then begin
      FTransParent := Value;
      FplBtn.Refresh;
    end;
  end;
  3:
  begin
    if FVertCenter <> Value then begin
      FVertCenter := Value;
      if FVertCenter then FplBtn.Refresh;
    end;
  end;
  4:
  begin
    if FHorzCenter <> Value then begin
      FHorzCenter := Value;
      if FHorzCenter then FplBtn.Refresh;
    end;
  end;
  end;
end;

//=============================================================================
//  C[W֌W̐ݒNX
//  摜\ʒu̐ݒ
//  Left       摜̍[̈ʒuDݒ肷HorzCenterFalseɂȂ
//  Top        摜̏[̈ʒuDݒ肷VertCenterFalseɂȂ
//=============================================================================
procedure TplBtnImage.SetImagePosition(const Index, Value: Integer);
begin
  case Index of
  1:
  begin
    if FLeft <> Value then begin
      FLeft := Value;
      FHorzCenter := False;
      FplBtn.Refresh;
    end;
  end;
  2:
  begin
    if FTop <> Value then begin
      FTop := Value;
      FVertCenter := False;
      FplBtn.Refresh;
    end;
  end;
  end;
end;

  {TplButton}

//=============================================================================
//  HeightWidht̏lW{^̃TCYƓƂ
//  LvpeB̏lݒ
//=============================================================================
constructor TplButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Height             := 26;
  Width              := 75;
  FButtonStyle       := bsNormal;
  FCancel            := False;
  FGradation         := True;
  FGradBeginColor    := clWhite;
  FGradEndColor      := clSilver;
  FCaptionLineSpace  := 4;
  FCaptionVertCenter := True;
  FFlatFrameType     := bffFlat;
  FHasFocus          := True;
  FModalResult       := mrNone;
  FRoundDiameter     := 7;
  FFlatFrameType     := bffFlat;
  TabStop            := True;
  FCaptionA          := TplBtnCaption.Create(Self);
  FCaptionB          := TplBtnCaption.Create(Self);
  FImage             := TplBtnImage.Create(Self);
end;

//=============================================================================
//  ̃R|[lgłTPanelCaptionvpeBgpȂ̂ŃNX^
//  vpeB̐ݒI,SetParentŃR|[lgCaptionAɂ.
//  (Text܂CaptionύXꂽCm_TextChangedbZ[W̔_ł͑
//  ăG[ƂȂ)
//=============================================================================
procedure TplButton.SetParent(AParent: TWinControl);
begin
  inherited;

  if AParent=nil then exit;

  if fgParent = False then begin
    fgParent := True;
    FCaptionA.Caption := Name;
  end;
end;

//=============================================================================
//  R|[lgLoad
//=============================================================================
procedure TplButton.Loaded;
begin
  inherited Loaded;
  inherited Color := Color;
end;

//=============================================================================
//  R|[lgj
//=============================================================================
destructor TplButton.Destroy;
begin
  FCaptionA.Free;
  FCaptionB.Free;
  if Assigned(FImage) then FImage.Free;
  DeleteObject(BtnRgn);

  inherited Destroy;
end;

//=============================================================================
//  ButtonStylevpeB̐ݒ
//  bsFlat            tbg
//  bsFlatNoFrame     tbgŎ̘͂gȂ
//  bsNormal          ftHgŒʏ̃{^g
//  bsRoundRect       pۂtbgȃ{^
//  bsRondRectNoFrame pۂăt[̂Ȃtbg{^
//=============================================================================
procedure TplButton.SetButtonStyle(const Value: TplButtonStyle);
begin
  if FButtonStyle <> Value then begin
    FButtonStyle := Value;
    if (FButtonStyle = bsRoundRect) or (FButtonStyle = bsRoundRectNoFrame) then begin
      BtnRgn := CreateRoundRectRgn(0, 0, Width+1, Height + 1, FRoundDiameter, FRoundDiameter);
      SetWindowRgn(Handle, BtnRgn, True);
    end else begin
      if BtnRgn <> 0 then begin
        SetWindowRgn(Handle, 0, True);
        DeleteObject(BtnRgn);
        BtnRgn := 0;
      end;
    end;
  end;
  Refresh;
end;

//=============================================================================
//  CaptionA܂CaptionBvpeB̕ύX
//=============================================================================
procedure TplButton.SetCaptionAorB(const Index: Integer;
  const Value: TplBtnCaption);
begin
  case Index of
  1: FCaptionA.Assign(Value);
  2: FCaptionB.Assign(Value);
  end;
  Refresh;
end;

//=============================================================================
//  ImagevpeB̕ύX
//=============================================================================
procedure TplButton.SetImage(const Value: TplBtnImage);
begin
  FImage.Assign(Value);
  Refresh;
end;

//=============================================================================
//  LvV̕Iɏ㉺ɔzu
//=============================================================================
procedure TplButton.SetCaptionVertCenter(const Value: Boolean);
begin
  if FCaptionVertCenter <> Value then begin
    FCaptionVertCenter := Value;
    if FCaptionVertCenter then Refresh;
  end;
end;

//=============================================================================
//   LvV̕`JnYWl
//   ݂YWlƓȂĕ`͂Ȃ
//=============================================================================
procedure TplButton.SetCaptionTop(const Value: Integer);
begin
  if FCaptionTop <> Value then begin
    FCaptionTop := Value;
      FCaptionVertCenter := False;
      Refresh;
  end;
end;

//=============================================================================
//  CaptionACaptionB̊Ԃ̃Xy[X̐ݒ
//=============================================================================
procedure TplButton.SetCaptionLineSpace(const Value: Integer);
begin
  if FCaptionLineSpace <> Value then begin
    FCaptionLineSpace := Value;
    Refresh;
  end;
end;

//=============================================================================
//  tbgŘgtŊpۂłȂg̎ޕύX\
//=============================================================================
procedure TplButton.SetFlatFrameType(const Value: TplBtnFrameType);
begin
  if FFlatFrameType <> Value then begin
    FFlatFrameType := Value;
    Refresh;
  end;
end;

//=============================================================================
//  TCYύXƂȂĕ`
//=============================================================================
procedure TplButton.WMSize(var Message: TWMSize);
begin
  inherited;

  if (FButtonStyle = bsRoundRect) or (FButtonStyle = bsRoundRectNoFrame) then begin
    DeleteObject(BtnRgn);
    BtnRgn := 0;
    BtnRgn := CreateRoundRectRgn(0, 0, Width + 1, Height + 1, FRoundDiameter, FRoundDiameter);
    SetWindowRgn(Handle, BtnRgn, True);
  end;
  Refresh;
end;

//=============================================================================
//  pۂ̃TCYύX(ȉ~̒a)
//=============================================================================
procedure TplButton.SetRoundDiameter(const Value: Integer);
begin
  if FRoundDiameter <> Value then begin
    FRoundDiameter := Value;
    if (FButtonStyle = bsRoundRect) or (FButtonStyle = bsRoundRectNoFrame) then begin
      DeleteObject(BtnRgn);
      BtnRgn := 0;
      BtnRgn := CreateRoundRectRgn(0, 0, Width + 1, Height + 1, FRoundDiameter, FRoundDiameter);
      SetWindowRgn(Handle, BtnRgn, False);
      Refresh;
    end;
  end;
end;

//=============================================================================
//  ParantColorύXꂽ̃bZ[W
//  R|ColorvpeBύXƂȂƂ̃R|̎qɑD
//  ̑ĂbZ[W̏D
//  (gɂ)qR|ParentColorTrueȂĕ`悪KvD
//  ,GradationTrue͖̎.
//=============================================================================
procedure TplButton.CMParentColorChanged(var Message: TMessage);
begin
  inherited;

  if ParentColor then Invalidate;
end;

//=============================================================================
//  Of[VLvpeB̐ݒ
//=============================================================================
procedure TplButton.SetGradation(const Value: Boolean);
begin
  if FGradation <> Value then begin
    FGradation := Value;
    if FGradation then ParentColor := False;
    Refresh;
  end;
end;

//=============================================================================
//  Of[V̊JnƏIF̐ݒ
//  GradBeginColorGradEndColorvpeB
//=============================================================================
procedure TplButton.SetGradColor(const Index: Integer;
  const Value: TColor);
begin
  if Index = 1 then begin
    if FGradBeginColor <> Value then begin
      FGradBeginColor := Value;
      Refresh;
    end;
  end else begin
    if FGradEndColor <> Value then begin
      FGradEndColor := Value;
      Refresh;
    end;
  end;
end;

//=============================================================================
//  tH[JX̗L̐ݒ
//=============================================================================
procedure TplButton.SetHasFocus(const Value: Boolean);
begin
  if FHasFocus <> Value then begin
    FHasFocus := Value;
    Refresh;
  end;
end;

//=============================================================================
//   ShiftL[̉Ԃ擾
//   MouseEnterMouseLeave̎ShiftL[̏Ԃ擾邽߂Ɏgp
//=============================================================================
function GetShiftState: TShiftState;
var
  KeyState : TKeyboardState;
begin
  GetKeyboardState(KeyState);
  Result := [];
  if KeyState[VK_MENU]    and $8000 <> 0 then Include(Result, ssAlt);
  if KeyState[VK_SHIFT]   and $8000 <> 0 then Include(Result, ssShift);
  if KeyState[VK_CONTROL] and $8000 <> 0 then Include(Result, ssCtrl);
  if KeyState[VK_LBUTTON] and $8000 <> 0 then Include(Result, ssLeft);
  if KeyState[VK_RBUTTON] and $8000 <> 0 then Include(Result, ssRight);
  if KeyState[VK_MBUTTON] and $8000 <> 0 then Include(Result, ssMiddle);
end;

//=============================================================================
//  [Enter]̂߂̃R[h
//  [Enter]łFocus鎞̓NbNƓɂ
//=============================================================================
procedure TplButton.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);

  if Enabled then begin
    if Key = VK_RETURN then begin
      Key := 0;
      inherited Click;
    end;
  end;
end;

//=============================================================================
//  [Enter]
//=============================================================================
procedure TplButton.KeyUp(var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    fgMouseDown := False;
    Invalidate;
  end;

  inherited KeyUp(Key, Shift);
end;

//=============================================================================
//  NbNCxg
//=============================================================================
procedure TplButton.Click;
var
  AForm : TForm;
begin
  fgMouseDown := False;
  AForm := TForm(GetParentForm(Self));
  if AForm <> nil then AForm.ModalResult := FModalResult;

  inherited;

  Invalidate;
end;

//=============================================================================
//  gɑCm_DialogKeybZ[W̏
//  CancelvpeB̏
//  CancelvpeB̓Ăł̂낤
//=============================================================================
procedure TplButton.CMDialogKey(var Message: TCMDialogKey);
begin
  with Message do begin
    if  (((CharCode = VK_RETURN) and (Self = Screen.ActiveControl)) or
        ((CharCode = VK_ESCAPE) and FCancel)) and
        (KeyDataToShiftState(Message.KeyData) = []) and FHasFocus then begin
      Click;
      Result := 1;
    end else begin
      inherited;
    end;
  end;
end;

//=============================================================================
//  }EXRg[ɓɂ̃Rg[ɑĂ
//  Cm_MouseEntetbZ[W̏DDelphi͂̃bZ[WeRg[ɑ
//  邱ƈȊO͉Ȃ̂Ŋeŏs
//  łMouseEnter\bhs(IParam)
//=============================================================================
procedure TplButton.CMMouseEnter(var Message: TMessage);
var
   Shift : TShiftState;
   Pos   : TPoint;
begin
  inherited;

  Shift := GetShiftState;
  GetCursorPos(Pos);
  Pos := ScreenToClient(Pos);
  MouseEnter(Shift, Pos.X, Pos.Y);
end;

//=============================================================================
//  Rg[̃}EXCxg
//=============================================================================
procedure TplButton.MouseEnter(Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if Assigned(FOnMouseEnter)   then FOnMouseEnter(Self, Shift, X, Y);
  if Windows.GetCapture = Handle then Refresh;
end;

//=============================================================================
//  }EXR|̋E𗣂Ă鎞ɑĂCm_MouseLeavebZ[W
//  Delphi͂̃bZ[WeR|ɑ邱ƈȊO͉Ȃ̂Ŏŏ
//  łMouseLeave\bhł̏s(IParambZ[W̑)
//=============================================================================
procedure TplButton.CMMouseLeave(var Message: TMessage);
var
  Shift : TShiftState;
  Pos   : TPoint;
begin
  inherited;

  Shift := GetShiftState;
  GetCursorPos(Pos);
  Pos := ScreenToClient(Pos);
  MouseLeave(Shift, Pos.X, Pos.Y);
end;

//=============================================================================
//  MouseLeaveCxg
//=============================================================================
procedure TplButton.MouseLeave(Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  if Assigned(FOnMouseExit) then FOnMouseExit(Self, Shift, X, Y);
  fgMouseDown := False;
  Refresh;
end;

//=============================================================================
//  MouseDown̏
//  {^̎HasFocusvpeBɉǉ
//=============================================================================
procedure TplButton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X,Y: Integer);
begin
  if Button=mbLeft then begin
    if FHasFocus then SetFocus;
    fgMouseDown := True;
    Refresh;
  end;

  inherited MouseDown(Button, Shift, X, Y);
end;

//=============================================================================
//  MouseUpCxg
//  {^̎HadFocsusvpeBɉǉ
//=============================================================================
procedure TplButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X,Y: Integer);
begin
   if Button = mbLeft then begin
     fgMouseDown := False;
     Refresh;
   end;

   inherited MouseUp(Button, Shift, X, Y);
end;

//=============================================================================
//  Rg[DoEnter
//  {^FocusedvpeBꍇ̂ݏ
//=============================================================================
procedure TplButton.DoEnter;
begin
  if FHasFocus then begin
    inherited;
    Invalidate;
  end;
end;

//=============================================================================
//  Rg[DoExit
//  {^Focusꍇ̂ݏ
//=============================================================================
procedure TplButton.DoExit;
begin
   if FHasFocus then begin
     inherited;
     Invalidate;
   end;
end;

//=============================================================================
//  R|EnabledvpeBύXꂽɃR|gɑĂ郁bZ[W
//  Cm_EnabledChanged̏
//  ̃R|Paintgōŝōĕ`sĂ
//  ̃bZ[W͈Ȃ̂TWmNoParamsgpD
//=============================================================================
procedure TplButton.CMEnabledChanged(var Message: TWMNoParams);
begin
    inherited;

    Invalidate;
end;
//=============================================================================
//  R|[lg̃yCg\bh(BitmapCanvas̍쐬)
//  ParentColor=False̎Canvasɒڕ`悷ƃ`̂BitmapCanvas
//  쐬ĕ`(ɃOf[V̎)
//=============================================================================
procedure TplButton.Paint;
var
    BtnBitmap  : TBitmap;
    DrawCanvas : TCanvas;
begin
    BtnBitmap := TBitmap.Create;
    try
      if ParentColor then begin
        BtnBitmap  := nil;
        DrawCanvas := Canvas;
        BtnDrawOnBitmapCanvas(DrawCanvas);
      end else begin
        BtnBitmap.Width  := Width;
        BtnBitmap.Height := Height;
        DrawCanvas       := BtnBitmap.Canvas;
        BtnDrawOnBitmapCanvas(DrawCanvas);
        Canvas.Draw(0,0,BtnBitmap);
      end;
    finally
      BtnBitmap.Free;
    end;
end;

//=============================================================================
//  R|[lg̃yCg\bh̎ۂ̕
//=============================================================================
procedure TplButton.BtnDrawOnBitmapCanvas(ACanvas: TCanvas);
var
   Y         : Integer;
   CapHeight : Integer;
begin
  ACanvas.Brush.Style := bsSolid;
  BtnRect := ClientRect;
  //Of[V̎
  if FGradation then begin
    GradPaint(ACanvas);
  //Of[VłȂꍇ
  end else begin
    ACanvas.Brush.Color := Color;
    ACanvas.FillRect(BtnRect);
  end;
  PutImagePicture(ACanvas);

  //Fontݒ
  ACanvas.Font.Assign(Font);
  //Fontɂ镶̍擾
  CapHeight := ACanvas.TextHeight(FCaptionA.Caption);
  //1sڂ̕`JnYWlvZ
  if FCaptionVertCenter then begin
    if FCaptionB.Caption <> '' then begin
      Y := (Height - 2 * CapHeight - FCaptionLineSpace) div 2;
    end else begin
      Y := (Height - CapHeight) div 2 + 1;
    end;
    FCaptionTop := Y;
    FCaptionVertCenter := True;
  end else begin
    Y := FCaptionTop;
  end;;
  BtnDrawCaption(ACanvas, FCaptionA,Y);
  //2sڂ̕`JnYWlvZ
  if FCaptionVertCenter then begin
    if FCaptionA.Caption <> '' then begin
      Y := Y + CapHeight + FCaptionLineSpace;
    end else begin
      CapHeight := ACanvas.TextHeight(FCaptionB.Caption);
      Y := (Height - CapHeight) div 2;
      FCaptionTop := Y;
      FCaptionVertCenter := True;
    end;
  end else begin
    Y := FCaptionTop + (CapHeight + FCaptionLineSpace) * Ord(FCaptionA.Caption <> '');
  end;;
  BtnDrawCaption(ACanvas, FCaptionB, Y);

  //{^FrameƓ̃tH[JX̕`
  ACanvas.Brush.Style := bsClear;
  BtnRect := ClientRect;
  //{^Og̕`
  BtnDrawFrame(ACanvas);
  //tH[JX̕`
  if (Self=Screen.ActiveControl) and (FHasFocus) then BtnDrawInnerFrame(ACanvas);
end;

//=============================================================================
//  摜`
//=============================================================================
procedure TplButton.PutImagePicture(ACanvas: TCanvas);
var
  X1         : Integer;
  Y1         : Integer;
  Offset     : Integer;
  Flag       : UINT ;
  TempBitmap : TBitmap;
begin
  if FImage.Visible = False then exit;
  if FImage.Picture.Graphic = nil then exit;

  Offset := Ord(FHasFocus) * Ord(fgMouseDown);
  if FImage.VertCenter then begin
    FImage.Top := (Height - FImage.Picture.Graphic.Height) div 2;
    FImage.VertCenter := True;
  end;
  if FImage.HorzCenter then begin
    FImage.Left := (Width - FImage.Picture.Graphic.Width) div 2;
    FImage.HorzCenter := True;
  end;
  X1 := FImage.Left + Offset;
  Y1 := FImage.Top  + Offset;

  if FImage.Picture.Graphic is TBitmap then begin
    //̃rbg}bv͂̂܂܂ɂĂ̂œpTempBitmap𐶐
    TempBitmap := TBitmap.Create;
    try
      TempBitmap.Assign(FImage.Picture.Bitmap);
      //rbg}bv̓ߏ
      if FImage.TransParent then begin
        TempBitmap.Transparent     := True;
        TempBitmap.TransparentMode := tmAuto;
        ACanvas.Draw(FImage.Left, FImage.Top, TempBitmap);
      end else begin
        //Enabled=False̎̓G{Xʂŕ`
        if (Enabled = False) and (FHasFocus) then Flag := DST_BITMAP or DSS_DISABLED
                                           else Flag := DST_BITMAP or DSS_NORMAL;
        DrawState(ACanvas.Handle, 0, nil, TempBitmap.Handle, 0, X1, Y1, 0, 0, Flag);
      end;
    finally
      TempBitmap.Free;
    end;
  end else if FImage.Picture.Graphic is TIcon then begin
    //Enabled=False̎̓G{Xʂŕ`
    if (Enabled=False) and (FHasFocus) then Flag := DST_ICON or DSS_DISABLED
                                       else Flag := DST_ICON or DSS_NORMAL;
    DrawState(ACanvas.Handle, 0, nil, FImage.Picture.Icon.Handle, 0, X1, Y1, 0, 0, Flag);
  end;
end;

//=============================================================================
//  LvVACapŸʒu`悷
//  Delphui2009ȍ~WideStringł삷邪CUnicodeł͂Ȃ
//=============================================================================
procedure TplButton.BtnDrawCaption(ACanvas: TCanvas;ACap: TplBtnCaption; Y:Integer);
var
  AWidth    : Integer;
  WLen      : Integer;
  dx        : Integer;
  i         : Integer;
  X         : Integer;
  XPos      : Integer;
  YPos      : Integer;
  AAlign    : TplBtnAlignment;
  Amaridots : Integer;
  Amari     : Integer;
  {$IFDEF VER130}
  WCaption : WideString;
  {$ELSE}
  {$IFDEF CONDITIONALEXPRESSIONS}    //ȉ̓T|[gĂȂ΃RpCȂ
    {$IF Declared(CompilerVersion)}  //CompilerVersin݂΃RpC(D6ȍ~͂)
      {$IF CompilerVersion<18.6}
      WCaption : WideString;
      {$ELSE}
      WCaption : String;
      {$IFEND}
    {$IFEND}
  {$ENDIF}
  {$ENDIF}
  CapStr    : String;
begin
  WCaption  := ACap.Caption;
  CapStr    := ACap.Caption;
  WLen      := Length(WCaption);
  AAlign    := ACap.Alignment;
  AWidth    := 0;
  dx        := 0;
  X         := 0;
  Amaridots := 0;
  AMari     := 0;

  if WLen=0 then exit;

  //`悷̂ACanvasBrushClear
  ACanvas.Brush.Style := bsClear;

  //ϓtł1̎͒ɕ`
  if (AAlign = taEven) and (WLen = 1) then AAlign := taCenter;
  if AAlign = taEven then begin
    X := 2 + ACap.Left;
    AWidth := Width - X - ACap.Right - 2;
  end else begin
    if AAlign = taLeft   then X := ACap.Left + 2;
    if AAlign = taRight  then X := Width - ACap.Right - 2;
    if AAlign = taCenter then X := Width div 2;
  end;
  SetTextAlign(ACanvas.Handle, BtnAlign[AAlign]);
  //}EXNbN̓ɑΉ(̕`ʒu1hbg炷)
  if FHasFocus and fgMouseDown then begin
    X := X + 1;
    Y := Y + 1;
  end;

  //ACgɉĕԃhbgvZ
  if AAlign = taEven then begin
    dx        := (AWidth - ACanvas.TextWidth(WCaption)) div (WLen - 1);
    Amaridots := (AWidth - ACanvas.TextWidth(WCaption)) mod (WLen - 1);
    Amari     := Amaridots;
  end;

  //Enabled=False̎Font`ĕ`
  //̐Fς1hbg炵ĕ`悷邱ƂɂăG{Xʂo
  if (Enabled = False) and (FHasFocus) then begin
    XPos := X;
    YPos := Y;
    ACanvas.Font.Color := clBtnHighlight;
    if AAlign = taEven then begin
      for i := 1 to WLen do begin
        ACanvas.TextOut(XPos + 1, YPos + 1, Copy(WCaption, i, 1));
        XPos := XPos+ACanvas.TextWidth(Copy(WCaption, i, 1)) + dx;
        if Amaridots > 0 then begin
          Inc(XPos);
          Dec(Amaridots);
        end else if Amaridots < 0 then begin
          Dec(XPos);
          Inc(Amaridots);
        end;
      end;
    end else begin
      TextOut(ACanvas. Handle, XPos + 1, YPos + 1, PChar(CapStr), Length(CapStr));
    end;
    //Enabled=False͎̎clBtnShadowŕ`悷
    ACanvas.Font.Color := clBtnShadow;
    Amaridots := Amari;
  end;

  //{^̃LvVʏ̈ʒuɕ`
  XPos := X;
  YPos := Y;
  if AAlign = taEven then begin
    for i := 1 to WLen do begin
      ACanvas.TextOut(XPos, YPos, Copy(WCaption, i, 1));
      XPos := XPos+ACanvas.TextWidth(Copy(WCaption, i, 1) )+ dx;
      if Amaridots > 0 then begin
        Inc(XPos);
        Dec(Amaridots);
      end else if Amaridots < 0 then begin
        Dec(XPos);
        Inc(Amaridots);
      end;
    end;
  end else begin
    TextOut(ACanvas.Handle, XPos, YPos, PChar(CapStr), Length(CapStr));
  end;
end;

//=============================================================================
//  {^̘g̕`
//  ̃\bh̓{^̃fUC̕Ȃ̂ŁCύXƂ낢ȃX^
//  Cɂł
//  FlatFrameType bffFlat    //
//                bffEtched  //񂾊
//                bffBump    //{オ
//=============================================================================
procedure TplButton.BtnDrawFrame(ACanvas: TCanvas);
begin
  if FButtonStyle = bsRoundRectNoFrame then exit;
  if FButtonStyle = bsFlatNoFrame then exit;

  //pۂX^C̎
  if FButtonStyle = bsRoundRect then begin
    ACanvas.Pen.Color := $00757575;
    ACanvas.Pen.Width := 1;
    ACanvas.RoundRect(0, 0, Width, Height, FRoundDiameter, FRoundDiameter);
  //tbgȃX^C̎
  end else if FButtonStyle=bsFlat then begin
    if FFlatFrameType = bffFlat   then DrawEdge(ACanvas.Handle, BtnRect, EDGE_BUMP,   BF_FLAT or BF_RECT);
    if FFlatFrameType = bffEtched then DrawEdge(ACanvas.Handle, BtnRect, EDGE_ETCHED, BF_RECT);
    if FFlatFrameType = bffBump   then DrawEdge(ACanvas.Handle, BtnRect, EDGE_BUMP,   BF_RECT);
  //̑̎
  end else begin
    //}EX̏
    if (fgMouseDown) then begin
     //܂ɂ͂̃R[h
      //DrawEdge(ACanvas.Handle,BtnRect,EDGE_SUNKEN,BF_RECT);
      Frame3D(ACanvas, BtnRect, clBtnShadow, clBtnShadow, 1);
      Frame3D(ACanvas, BtnRect, clGray, clGRay, 1);
    end else begin
      //ʂ̃{^
      DrawEdge(ACanvas.Handle, BtnRect, EDGE_RAISED, BF_RECT);
    end;
  end;
end;

//=============================================================================
//  tH[JX鎞̃tH[JXp_̕`
//  FlatFrameType bffFlat    //
//                bffEtched  //񂾊
//                bffBump    //オ
//=============================================================================
procedure TplButton.BtnDrawInnerFrame(ACanvas: TCanvas);
var
  SaveFontColor : TColor;
  lplb          : LOGBRUSH;
  PenHandle     : HWND;
begin
  BtnRect := ClientRect;
  if (FButtonStyle = bsRoundRect) or (FButtonStyle = bsRoundRectNoFrame) then begin
    lplb.lbColor := $00202020;
    lplb.lbStyle := BS_SOLID;
    PenHandle    := ExtCreatePen(PS_COSMETIC or PS_ALTERNATE, 1, lplb, 0, nil);
    try
      SelectObject(ACanvas.Handle, PenHandle);
      Windows.RoundRect(ACanvas.Handle, 2, 2, Width - 2, Height - 2, FRoundDiameter - 2, FRoundDiameter - 2);
    finally
      DeleteObject(PenHandle);
    end;
  end else begin
    InflateRect(BtnRect, -2, -2);
    if (FButtonStyle = bsFlat) then begin
      if (FFlatFrameType = bffBump) then begin
        Inc(BtnRect.Right);
        Inc(BtnRect.Bottom);
      end else if (FFlatFrameType = bffEtched) then begin
        Dec(BtnRect.Right);
        Dec(BtnRect.Bottom);
      end;
    end;
    SaveFontColor := ACanvas.Font.Color;
    try
      //DrowFocusRectFont.Color̕Fŕ`悷炵
      ACanvas.Font.Color := clWhite;
      Windows.DrawFocusRect(ACanvas.Handle, BtnRect);
    finally
      ACanvas.Font.Color := SaveFontColor;
    end;
  end;
end;

//=============================================================================
//  Of[V̕`
//  AIɕωĂ̂ŁC̓Of[V̕ω̃XebvςĂ
//  ̂mȂD
//  FGradBeginColor Jn̐FŃ{^[̐F
//  FGradEndColor   I̐FŃ{^[̐F
//
//  EndCol,StartCol̃R[hC
//  VXeJ[IꍇɐFfȂ̂C
//  (NanaɊ)
//=============================================================================
procedure TplButton.GradPaint(ACanvas: TCanvas);
var
  StartCol : COLORREF;
  EndCol   : COLORREF;
  R        : Byte;
  G        : Byte;
  B        : Byte;
  i        : Integer;
  LineCnt  : Integer;
begin
  EndCol   := GetNearestColor( ACanvas.Handle, ColorToRGB(FGradEndColor));
  StartCol := GetNearestColor( ACanvas.Handle, ColorToRGB(FGradBeginColor));

  LineCnt := Height;
  if LineCnt > 1 then begin
    for i := 0 to LineCnt-1 do begin
      //FRGB`ŃZbg
      R := (GetRValue(EndCol) - GetRValue(StartCol)) * i div
           (LineCnt - 1) + GetRValue(StartCol);
      G := (GetGValue(EndCol) - GetGValue(StartCol)) * i div
           (LineCnt - 1) + GetGValue(StartCol);
      B := (GetBValue(EndCol) - GetBValue(StartCol)) * i div
           (LineCnt - 1) + GetBValue(StartCol);
      ACanvas.Pen.Color := RGB(R, G, B);
      ACanvas.MoveTo(0, i);
      ACanvas.LineTo(Width, i);
    end
   //1x1 ł̓Of[V\łȂ̂ŁAStartColorŕ\
  end else if LineCnt = 1 then begin
    ACanvas.Pen.Color := RGB(GetRValue(StartCol),
                             GetGValue(StartCol),
                             GetBValue(StartCol));
    ACanvas.MoveTo(0, 0);
    ACanvas.LineTo(Width, 0);
  end;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplButton]);
end;

end.









